--------------------------------------------------------------------------
-- Assirc_Database.Alignment                Copyrigth ENS ULM 1996-1999 --
-- Pierre VINCENS                   V 00.000                 10/01/1999 --
--------------------------------------------------------------------------
with Ada.Unchecked_Deallocation;
with Ada.Text_Io; use Ada.Text_Io;
with Type_Specifications.IO; use Type_Specifications.IO;
with Strlib; use Strlib;
with Options_Util; use Options_Util;
  
with Sequence_Specifications; use Sequence_Specifications;
with Sequence_Specifications.Basic; use Sequence_Specifications.Basic;
with Assirc_Specifications.Database; use Assirc_Specifications.Database;
with Assirc_Global_Variables; use Assirc_Global_Variables;
with Assirc_Database_Functions; use Assirc_Database_Functions;

with Sequence_Alignment; use Sequence_Alignment;
with Sequence_Alignment.Basic; use Sequence_Alignment.Basic;

package Assirc_Database.Alignment is
  
  type Output_Display is record
    File   : Boolean;
    Screen : Boolean;
  end record;
  File_Only       : constant Output_Display := (File => True, Screen => False);
  Screen_Only     : constant Output_Display := (File => False,Screen => True);
  File_And_Screen : constant Output_Display := (File => True, Screen => True);
  
  procedure Perform_Alignments(Name : in String;
			       Display : in Output_Display;
			       Minimal_Length : in Integer;
			       Minimal_Similarity : in Percentage;
			       Method : in Alignment_Method;
			       Mismatch_Weight, Match_Weight : in Integer;
			       Gap_Weight,Gap_Length_Weight : in Integer;
			       With_End_Weight : in Boolean;
			       Max_Length : in Integer;
			       Adjust : in Integer;
			       Similarity_Threshold : in Integer;
			       Randomization : in Integer;
			       Preserve : in Integer);

end Assirc_Database.Alignment;
