--------------------------------------------------------------------------
-- Assirc_Options                           Copyrigth ENS ULM 1996-1997 --
-- Pierre VINCENS                   V 00.000                 10/04/1996 --
-- Pierre VINCENS                   V 01.000                 24/07/1997 --
--------------------------------------------------------------------------
-- Traitement de la ligne de commande du programme Assirc
--------------------------------------------------------------------------
with Strlib; use Strlib;
with Sequence_Specifications; use Sequence_Specifications;
with Sequence_Specifications.Basic; use Sequence_Specifications.Basic;
with Sequence_Alignment; use Sequence_Alignment;
with Assirc_Specifications; use Assirc_Specifications;

package Assirc_Options is

  INVALID_DATA : exception;
  -- Leve si la valeur d'une option est invalide 
  -- ATTENTION, une erreur de specification de format ou de brin
  -- lve une exception spcifique 

  type Options_Choice_Type is (Check,Build);
  type Options_Type is record
    --Choice : Options_Choice_Type := Build;
    Seed_Size : Integer := 11;
    Mask_Size : Integer := 2;
    Distance : Integer := 5;
    Final_Length : Integer := 300;
    Min_Similarity : Integer := 0;
    Recorded_Length : Integer := 0;
    Nb_Sequences  : Integer := 1;
    Output : Varstring;        -- Nom du fichier d'enregistrement des rsultats
    Name : Varstring;          -- Nom du fichier de la liste des squences
    Name1,Name2 : Varstring;   -- Noms des squences 1 et 2
    Identifier1 : Varstring;
    Identifier2 : Varstring;
    Start1,Stop1,Start2,Stop2 : Integer := Complete;
    Strand1,Strand2 : Strand_Type := Both;
    Opposite1,Opposite2 : Boolean := False;
    Complementary1,Complementary2 : Boolean := False;
    Format1,Format2 : Sequence_Format := Unknown;
    Xonly : Boolean := False;
    Tolerance : Integer := 10;
    Skip : Integer := 0;
    Common_Max_Dist : Integer := 50;
    Excluded_Marge : Integer := 10;
    Intersection_Marge : Integer := 30;
    Shift : Shift_Model := Shift_Default;
    Shift_Name : Varstring;
    Regions_Mode : Boolean := False;
    Regions_Length : Integer := 50000;
    Regions_Overlap : Integer := 500;
    Verbose : Boolean := False;
    Summary : Boolean := True;
     -- Specifique pour Ltr_Assirc
    Min_Dist_Seeds : Natural := 1000;
    Max_Dist_Seeds : Natural := 15000;
    -- Alignment
    Alignment : Boolean := True;
    Alignment_Method : Sequence_Alignment.Alignment_Method := Local_Alignment;
    Match_Weight : Integer := 10;
    Mismatch_Weight : Integer := -9;
    Gap_Weight : Integer := -50;
    Gap_Length_Weight : Integer := -3;
    Similarity_Threshold : Integer := -1;
    Randomization : Integer := 0;
    Preserve : Integer := 1;
    With_End_Weight   : Boolean := False;
    Max_Length : Integer := 3500;
    Adjust : Integer := 0;
  end record;

  procedure Get_Options(Options : in out Options_Type);

  procedure Print_Options;

end Assirc_Options;
