--------------------------------------------------------------------------
-- Assirc                                   Copyrigth ENS ULM 1996-1998 --
-- Pierre VINCENS                   V 00.000                 10/04/1996 --
-- Pierre VINCENS                   V 01.000                 16/04/1998 --
--------------------------------------------------------------------------
-- Lecture des sequences
--------------------------------------------------------------------------
with Ada.Unchecked_Conversion;
with Ada.Text_Io; use  Ada.Text_Io;

with Type_specifications; use Type_Specifications;
with Strlib; use Strlib;

with Sequence_Specifications; use Sequence_Specifications;
with Sequence_Specifications.Basic; use Sequence_Specifications.Basic;

with Assirc_Specifications; use Assirc_Specifications;
with Assirc_Specifications.Basic; use Assirc_Specifications.Basic;

package Assirc_Read is

  procedure Read_One_Sequence(Name          : in String;
                              Identifier    : in Varstring;
                              Id            : in Accession_Type;
                              Format        : in Sequence_Format;
                              Strand        : in Strand_Type;
                              Start, Stop   : in out Integer;
                              Sequence      : in out Assirc_Sequence_Data;
                              Opposite      : in Boolean := False;
                              Complementary : in Boolean := False;
			      Verbose       : in Boolean := False);
  -- Lecture d'une sequence dans le fichier specifie 

  function Read_List_Of_Sequences(Name    : in String;
				  Verbose : in Boolean := False) 
				  return Assirc_Sequence_Array_Access;
  -- Les squences sont lues d'aprs les instructions d'un fichier
  -- Le format de ce fichier est le suivant:
  --  Nom_Sequence Format Brin Identificateur Debut Fin
  -- Le blanc est un sparateur. Un diese en debut de ligne specifie une 
  -- ligne de commentaire.

  function Define_Shift(Model : in Shift_Model;
			Name  : in String) return Shift_Access;
  -- Dfinition des parametres d'un shift. Si le shift_model est shift_null,
  -- les valeurs sont lues dans un fichier de nom Name.

end Assirc_Read;
