--------------------------------------------------------------------------
-- Assirc_Seeds.D_Eval_M1                   Copyrigth ENS ULM 1996-1998 --
-- Pierre VINCENS                   V 00.000                 10/04/1996 --
-- Pierre VINCENS                   V 01.000                 23/03/1998 --
-- Pierre VINCENS                   V 01.001                 20/04/1998 --
-- Pierre VINCENS                   V 01.002                 07/02/2000 --
--------------------------------------------------------------------------
-- Evaluation des graines (Version distribue simple)
-- Dans cette version, la base de donnes des graines est locale  la
-- partition. Les rsultats sont transmis en fin de calcul  la base
-- de donnes commune. La repartition se fait par decoupage de la 
-- premiere sequence. ATTENTION: cette methode ne s'applique qu'a la 
-- comparaison de deux sequences
--------------------------------------------------------------------------
-- V 01.001
-- L'appel de Eval_Seeds a ete modifie (sequences est maintenant un 
-- pointeur sur le tableau et non plus le tableau). Cette version n'inclut
-- pas de mecanisme de controle sur les brins a conserver contrairement
-- aux autres versions, par il existe une verification plus complexe
-- sur les regions. Le controle sur les brins est suppose avoir ete
-- realise au prealable par les programmes appelant.
--------------------------------------------------------------------------
-- V 01.002
-- Cette nouvelle version inclut a nouveau un mecanisme de controle sur 
-- les brins a conserver, les verifications prealables etant insuffisantes.
--------------------------------------------------------------------------

package Assirc_Seeds.D_Eval_M1 is
  
  procedure Reset_Pairs_To_Check;
  pragma Inline(Reset_Pairs_To_Check);
  -- Cette procedure remet a zero la table de determination des paires
  -- de brins a traiter. Celle-ci est calculee automatiquement lors du
  -- premier appel de Eval_Seeds

  procedure Eval_Seeds(Sequences         : in Assirc_Sequence_Array_Access;
                       Seeds             : in out Seed_Segments;
                       Min_Length        : in Integer;
                       Max_Dist          : in Integer;
                       Tolerance         : in Integer;
                       Common_Max_Dist   : in Integer;
                       Skip              : in Integer;
                       Xonly             : in Boolean;
                       Zone1,Zone2       : in Segment_Type;
		       Z1_Xonly,Z2_Xonly : in Boolean);
  pragma Inline(Eval_Seeds);
  -- Dtermination de la similarit de la rgion se trouvant autour
  -- de chaque graine par une mthode d'extension mesurant la distance
  -- sparant des marches alatoires. Les parametres Zone1 et Zone2 
  -- definissent l'intervalle dans lesquelles sont recherches les duplications
  -- Z1_Xonly et Z2_Xonly indiquent si l'on doit ou non faire une recherche
  -- de la zone contre elle-meme

  procedure Send_Pairs(Minimal_Length : in Integer);
  pragma Inline(Send_Pairs);
  -- Transmission des donnes en fin de traitement. Cela a pour effet
  -- de vider l'arbre

end Assirc_Seeds.D_Eval_M1;
