--------------------------------------------------------------------------
-- Assirc_Seeds.D_Eval_M2                   Copyrigth ENS ULM 1996-1998 --
-- Pierre VINCENS                   V 00.000                 10/04/1996 --
-- Pierre VINCENS                   V 01.000                 23/03/1998 --
-- Pierre VINCENS                   V 01.001                 17/04/1998 --
-- Pierre VINCENS                   V 01.002                 24/06/1999 --
--------------------------------------------------------------------------
-- Evaluation des graines (Version distribue simple)
-- Dans cette version, il y a simplement un appel au RCI de la base de
-- donnes pour verifier l'inclusion ventuelle d'une lment dans la base
-- et donc ne pas le retester et un appel  l'ajout d'une nouvelle paire
-- La limitation principale tient dans le fait que durant ces deux appels
-- le processus est suspendu.
--------------------------------------------------------------------------
-- V 01.001
-- Les evolutions portent sur:
--   1/ La transmission des paires a la base donnees se fait maintenant a 
-- l'aide de plusieurs taches independante, un mecanisme assurant la 
-- repartition des paires entre ces taches
--   2/ L'echange des paires entre la base de donnees et ce module se fait
-- par paquet reduisant ainsi le nombre de transactions
--   3/ Le controle de la determination des paires a tester en fonction des
-- brins a analyser a ete integre. Le calcul des paires est fait lors du
-- premier appel a eval_seeds. Si le tableau des sequences changent, il faut
-- appeler la nouvelle procedure Reset_Pairs_To_Check pour remettre a zero
-- cette structure
--   4/  L'appel de Eval_Seeds a ete modifie (sequences est maintenant un 
-- pointeur sur le tableau et non plus le tableau lui-meme).
--------------------------------------------------------------------------
-- V 01.002
-- Le systme gre mainetnant une base de donnes locale dans laquelle
-- sont enregistr toutes les paires dtectes dans la partition. Cette
-- base permet de ne pas poster  la base distante les graines appartenant
--  des paires dtctes localement. La procedure Close_Local_Database 
-- permet de dtruire la base locale en fin de traitement.
--------------------------------------------------------------------------

package Assirc_Seeds.D_Eval_M2 is

  procedure Reset_Pairs_To_Check;
  pragma Inline(Reset_Pairs_To_Check);
  -- Cette procedure remet a zero la table de determination des paires
  -- de brins a traiter. Celle-ci est calculee automatiquement lors du
  -- premier appel de Eval_Seeds

  procedure Eval_Seeds(Sequences       : in Assirc_Sequence_Array_Access;
                       Seeds           : in out Seed_Segments;
                       Min_Length      : in Integer;
                       Max_Dist        : in Integer;
                       Tolerance       : in Integer;
                       Common_Max_Dist : in Integer;
                       Skip            : in Integer;
                       Xonly           : in Boolean);
  pragma Inline(Eval_Seeds);
  -- Dtermination de la similarit de la rgion se trouvant autour
  -- de chaque graine par une mthode d'extension mesurant la distance
  -- sparant des marches alatoires

end Assirc_Seeds.D_Eval_M2;
