--------------------------------------------------------------------------
-- Assirc_Seeds.D_Eval_M4                   Copyrigth ENS ULM 1996-1999 --
-- Pierre VINCENS                   V 01.000                 24/06/1999 --
--------------------------------------------------------------------------
-- Evaluation des graines (Version distribue de la base de donnes)
-- Dans cette version, la partition rcupre au fur et  mesure les
-- paires dtectes dans la base distante
--------------------------------------------------------------------------
with Dassirc_Common; use Dassirc_Common;

package Assirc_Seeds.D_Eval_M4 is

  procedure Start_Local_Database(Client : in Client_Id);
  procedure Shutdown_Local_Database;
  procedure Stop_Local_Database;
  pragma Inline(Start_Local_Database,
		Shutdown_Local_Database,
		Stop_Local_Database);
  -- Controle de la tache de gestion de rcupration des donnes
  -- depuis la base distante pour alimenter la base locale
  -- NOTE: Start_Local_Database doit etre appel pour activer la
  -- tache qui sera arret par Stop_Local_Database en fin de traitement
  -- Shutdown_Local_Database doit etre appel pour dsactiver la tache
  -- si ce type de traitement n'est pas retenu

  procedure Reset_Pairs_To_Check;
  pragma Inline(Reset_Pairs_To_Check);
  -- Cette procedure remet a zero la table de determination des paires
  -- de brins a traiter. Celle-ci est calculee automatiquement lors du
  -- premier appel de Eval_Seeds

  procedure Eval_Seeds(Sequences       : in Assirc_Sequence_Array_Access;
                       Seeds           : in out Seed_Segments;
                       Min_Length      : in Integer;
                       Max_Dist        : in Integer;
                       Tolerance       : in Integer;
                       Common_Max_Dist : in Integer;
                       Skip            : in Integer;
                       Xonly           : in Boolean);
  pragma Inline(Eval_Seeds);
  -- Dtermination de la similarit de la rgion se trouvant autour
  -- de chaque graine par une mthode d'extension mesurant la distance
  -- sparant des marches alatoires

end Assirc_Seeds.D_Eval_M4;
