--------------------------------------------------------------------------
-- Assirc_Specifications.Basic              Copyrigth ENS ULM 1996-1998 --
-- Pierre VINCENS                   V 00.000                 10/04/1996 --
-- Pierre VINCENS                   V 01.000                 12/03/1998 --
--------------------------------------------------------------------------
-- Dfinition des type de donnes de base du programme Assirc interdisant
-- de pouvoir donner la proprit PURE au paquetage pre
--------------------------------------------------------------------------

with Ada.Unchecked_Deallocation;
with Strlib; use Strlib;
with Sequence_Specifications; use Sequence_Specifications;
with Sequence_Specifications.Basic; use Sequence_Specifications.Basic;

package Assirc_Specifications.Basic is

  ------------------------------------------------------------------------
  -- Modle des dplacements                                            --
  ------------------------------------------------------------------------
  type Shift_Access is access Shift_Type;

  ------------------------------------------------------------------------
  -- Mmorisation des sequences                                         --
  ------------------------------------------------------------------------
  type Assirc_Sequence_Data is new Sequence_Data with record
    Id         : Accession_Type; -- identificateur numrique de la squence
    Strand     : Strand_Type;    -- prcise le brin  traiter
  end record;
  type Assirc_Sequence_Array is array(Accession_Type range <>) of 
    Assirc_Sequence_Data;
  type Assirc_Sequence_Array_Access is access Assirc_Sequence_Array;
  procedure Free is new 
    Ada.Unchecked_Deallocation(Assirc_Sequence_Array,
			       Assirc_Sequence_Array_Access);
  
end Assirc_Specifications.Basic;
