--------------------------------------------------------------------------
-- Cpu_Times.Counters                       Copyrigth ENS ULM 1996-1999 --
-- Pierre VINCENS                   V 01.000                 31/05/1999 --
--------------------------------------------------------------------------
-- Ce paquetage permet de recuperer le temps d'execution du programme
-- Sous linux, chaque tache s'executant sous un process different.
-- Le principe consiste  enregistrer chaque tache (et le main) au dbut
-- et  signaler leur terminaison ou on enregistre le temps consomme. 
-- La procedure elapsed_times remet a jour le temps consomme a chaque appel
--
-- Sous Solaris, les taches s'executant sous le meme process, on se contente
-- de faire l'appel  elepased_times pour dterminer le temps consomme
--
-- Sous Windows, on procede de meme que sous Solaris, mais ce n'est pas 
-- valid pour l'instant
--------------------------------------------------------------------------

with Cpu_Times; use Cpu_Times;
with Cpu_Times.Basic; use Cpu_Times.Basic;
with Cpu_Times.Utilities; use Cpu_Times.Utilities;

package Cpu_Times.Counters is

--------------------------------------------------------------------------
-- Un type protg pour memoriser la liste des process                  --
--------------------------------------------------------------------------
  protected Cpu_Counters is 
    procedure Add(Key : in String);
    -- Enregistrer la nouvelle tache
    procedure Remove;
    -- Indiquer que la tache est termine
    procedure Update_Childs;
    -- Prendre en compte la liste des process fils des process deja enregistre
    procedure Print_Process_List;
    -- Imprimer a l'cran la liste des taches et le cpu consomme par tache
    procedure Print_Elapsed_Times;
    -- Mettre a jour le temps consomme pour chaque tache et afficher le 
    -- temps total a l'ecran
    procedure Elapsed_Times(Times : in out Cpu_Duration);
    -- Mettre a jour le temps consomme pour chaque tache et retourner
    -- dans times le temps total cpu consomme
  private
    Pid_List      : Process_List;
  end Cpu_Counters;

end Cpu_Times.Counters;
