--------------------------------------------------------------------------
-- Dassirc_Alignment                        Copyrigth ENS ULM 1996-1999 --
-- Pierre VINCENS                   V 00.000                 04/06/1999 --
--------------------------------------------------------------------------
-- Realisation d'un alignement en but de validation
--------------------------------------------------------------------------

  
with Sequence_Specifications; use Sequence_Specifications;
with Sequence_Specifications.Basic; use Sequence_Specifications.Basic;

with Sequence_Alignment; use Sequence_Alignment;
with Sequence_Alignment.Basic; use Sequence_Alignment.Basic;

with Assirc_Specifications;use Assirc_Specifications;
with Assirc_Specifications.Basic;use Assirc_Specifications.Basic;
with Assirc_Specifications.Database; use Assirc_Specifications.Database;
with Assirc_Global_Variables; use Assirc_Global_Variables;
with Assirc_Database_Functions; use Assirc_Database_Functions;

package Dassirc_Alignment is

  procedure Perform_One_Alignment
    (Sequences            : in Assirc_Sequence_Array_Access;
     Pair                 : in out Segment_Pair;
     Summary              : out Alignment_Summary_Model;
     Method               : in Alignment_Method;
     Max_Length           : in Integer := 3500;
     Adjust               : in Integer := 0;
     Match_Weight         : in Integer := 100;
     Mismatch_Weight      : in Integer := -90;
     Gap_Weight           : in Integer := -500;
     Gap_Length_Weight    : in Integer := -30;
     With_End_Weight      : in Boolean := False;
     Similarity_Threshold : in Integer := -1;
     Randomization        : in Integer := 0;
     Preserve             : in Integer := 1);
  -- Cette procedure ne retourne que le summary

end Dassirc_Alignment;
