--------------------------------------------------------------------------
-- Dassirc_Semaphore                        Copyrigth ENS ULM 1996-1999 --
-- Pierre VINCENS                   V 01.000                 21/06/1999 --
--------------------------------------------------------------------------
-- Semaphore pour controler l'acces a la base de donnes. 
--------------------------------------------------------------------------

package Dassirc_Semaphore is

    protected Dispatcher_Access is
      -- Semaphore permettant de controler les accs au
      -- dispatcher 
      -- L'acces concurrent ne fonctionne pas en remote (bug ou non)
      entry Lock; 
      -- La tache prend la main et ferme l'acces. Si l'acces est ferme, la 
      -- tache appelante doit attendre qu'une autre tache est deverouille l'acces
      procedure Unlock; 
      -- la tache ayant bloquee (pas de controle explicite) libere le lock    
    private
      Door : Boolean := True; -- true -> acces possible, false -> accs bloquant
    end Dispatcher_Access;

    protected Database_Access is
      -- Semaphore permettant de controler les accs  la 
      -- vrification de la prsence de graines dans la base.
      -- L'acces concurrent ne fonctionne pas en remote (bug ou non)
      entry Lock; 
      -- La tache prend la main et ferme l'acces. Si l'acces est ferme, la 
      -- tache appelante doit attendre qu'une autre tache est deverouille l'acces
      procedure Unlock; 
      -- la tache ayant bloquee (pas de controle explicite) libere le lock    
    private
      Door : Boolean := True; -- true -> acces possible, false -> accs bloquant
    end Database_Access;

end Dassirc_Semaphore;
