--------------------------------------------------------------------------
-- Generic_Quicksort                        Copyrigth ENS ULM 1986-1997 --
-- Jean-Arcady MEYER                V 00.000                 12/06/1987 --
-- Pierre VINCENS                   V 01.000                 07/06/1997 --
--------------------------------------------------------------------------
with type_specifications; use  type_specifications;

package body Generic_Quicksort is

  use Real_Lib;

  procedure Exchange (Left  : in out Item;
                      Right : in out Item) is

    Temporary_Item : Item := Left;

  begin
    Left := Right;
    Right := Temporary_Item;
  end Exchange;

  procedure Quicksort(The_Items : in out Items) is

    M : constant Integer :=
      Integer(Log(Real(The_Items'Length))/Log(2.0));

    type Stack_Element is record
      L,R : Index;
    end record;

    Stack   : array(1..M) of Stack_Element;
    I,J,L,R : Index;
    X       : Item;
    S       : Integer range 0..M;

  begin

    S := 1;
    Stack(1).L := The_Items'First;
    Stack(1).R := The_Items'Last;

    loop
      L := Stack(S).L;
      R := Stack(S).R;
      S := S-1;
      loop
        I := L;
        J := R;
        X := The_Items(Index'Val((Index'Pos(L)+Index'Pos(R)) / 2));
        loop
          while The_Items(I) < X loop I := Index'Succ(I); end loop;
          while X < The_Items(J) loop J := Index'Pred(J); end loop;
          if I <= J then
            Exchange(The_Items(I),The_Items(J));
            I := Index'Succ(I);
            J := Index'Pred(J);
          end if;
          exit when I > J;
        end loop;
        if Index'Pos(J)-Index'Pos(L) < Index'Pos(R)-Index'Pos(I) then
          if I < R then
            S := S+1;
            Stack(S).L := I;
            Stack(S).R := R;
          end if;
          R := J;
        else
          if L < J then
            S := S+1;
            Stack(S).L := L;
            Stack(S).R := J;
          end if;
          L := I;
        end if;
        exit when L >= R;
      end loop;
      exit when S = 0;
    end loop;
  end Quicksort;

end Generic_Quicksort;
