--------------------------------------------------------------------------
-- Sequence_Alignment.Utils.IO              Copyrigth ENS ULM 1996-1999 --
-- Pierre VINCENS                   V 00.000                 16/03/1999 --
--------------------------------------------------------------------------
-- Entre-sortie sur les fichiers de matrices de score
--------------------------------------------------------------------------
with Ada.Unchecked_Deallocation;

with Strlib; use  Strlib;
with Fifo;

with Ada.Text_Io; use Ada.Text_Io;
with Type_Specifications.IO; use Type_Specifications.IO;
use  Type_Specifications.IO.Int_IO;

with Sequence_Specifications; use Sequence_Specifications;
with Sequence_Specifications.Basic; use Sequence_Specifications.Basic;

with Sequence_Alignment.Utils;
with Sequence_Alignment.Basic; use Sequence_Alignment.Basic;

pragma Elaborate_All(Sequence_Alignment.Utils);

package Sequence_Alignment.Utils.Io is

  function Get_Nucleotide_Match_Matrix is new 
    Get_Match_Matrix(Nucleotide_Type,
		     Nucleotide_Match_Matrix,
		     To_Nucleotide);
  -- Lit une matrice de scores nucliques dans le fichier name

  procedure Print_Nucleotide_Match_Matrix is new
    Print_Match_Matrix(Nucleotide_Type,
		       Nucleotide_Match_Matrix,
		       To_Character);
  -- Affiche une matrice de scores nucliques

  function Get_Protein_Match_Matrix is new 
    Get_Match_Matrix(Amino_Acid_Type,
		     Protein_Match_Matrix,
		     To_Amino_Acid);
  -- Lit une matrice de scores proteiques dans le fichier name

  procedure Print_Protein_Match_Matrix is new
    Print_Match_Matrix(Amino_Acid_Type,
		       Protein_Match_Matrix,
		       To_Character);
  -- Affiche une matrice de scores protiques
  

end Sequence_Alignment.Utils.Io;
