--------------------------------------------------------------------------
-- Statistics                               Copyrigth ENS ULM 1996-2004 --
-- Pierre VINCENS                   V 00.001                 01/03/2004 --
--------------------------------------------------------------------------
with Type_Specifications; use Type_Specifications;

package body Statistics is
  
  type Statistic_Value is record 
    Alpha : Real;
    Value : Real;
  end record;
  type Statistic_Array is array (Integer range <>) of Statistic_Value;
  
  Loi_Normale : constant Statistic_Array :=
    ((0.000000001,  6.10941), (0.00000001,   5.73073),
     (0.0000001,    5.32672), (0.000001,     4.89164),
     (0.00001,      4.41717), (0.0001,       3.89059),
     (0.001,        3.29053), (0.01,         2.57600),
     (0.02,         2.326),   (0.03,         2.170),
     (0.04,         2.054),   (0.05,         1.960),
     (0.06,         1.881),   (0.07,         1.812),
     (0.08,         1.751),   (0.09,         1.695),
     (0.10,         1.645),   (0.15,         1.440),
     (0.20,         1.282),   (0.25,         1.150),
     (0.30,         1.036),   (0.35,         0.935),
     (0.40,         0.842),   (0.45,         0.755),
     (0.50,         0.674),
     (0.60,         0.524),
     (0.70,         0.385),
     (0.80,         0.253),
     (0.90,         0.126),
     (0.99,         0.013),   (1.00,         0.000));
     
     
  function Normale(Zscore : in Real) return Real is
    
  begin
    for I in Loi_Normale'Range loop
      if Zscore > Loi_Normale(I).Value then
	return Loi_Normale(I).Alpha * 100.0;
      end if;
    end loop;
    return 100.0;
  end Normale;
  
end Statistics;
