--------------------------------------------------------------------------
-- Yaap_Options                             Copyrigth ENS ULM 1996-2000 --
-- Pierre VINCENS                   V 01.000                 17/03/1999 --
-- Pierre VINCENS                   V 01.001                 16/02/2000 --
--------------------------------------------------------------------------
-- Traitement de la ligne de commande du programme Yaap
--------------------------------------------------------------------------
-- V 01.001
-- Ajout l'option Summary vrai par defaut qui controle l'affichage a 
-- l'ecran des paires trouvees.
--------------------------------------------------------------------------
with Ada.Text_Io; use  Ada.Text_Io;
with Ada.Command_Line; use Ada.Command_Line;
with Ada.Exceptions; use Ada.Exceptions;

with Type_specifications; use Type_specifications;
with Type_Specifications.IO; use Type_Specifications.IO;
use  Type_Specifications.IO.Int_Io;
use  Type_Specifications.IO.Real_Io;
use  Type_Specifications.Real_Lib;

with Strlib; use  Strlib;
with Options_Util; use  Options_Util;

with Sequence_Specifications; use Sequence_Specifications;
with Sequence_Specifications.Basic; use Sequence_Specifications.Basic;
with Sequence_Io; use  Sequence_Io;

with Sequence_Alignment; use Sequence_Alignment;
with Sequence_Alignment.Print; use Sequence_Alignment.Print;
with Sequence_Alignment.Global; use Sequence_Alignment.Global;
with Sequence_Alignment.Local; use Sequence_Alignment.Local;

with Yaap_Version; use Yaap_Version;

package Yaap_Options is

  INVALID_DATA : exception;
  -- Leve si la valeur d'une option est invalide 
  
  type Options_Type is record
    Method : Alignment_Method := Global_Alignment;
    Building : Building_Method := One;
    Optimize : Optimize_Method := No;
    Progression : Progression_Method := DVH;
    Name1,Name2 : Varstring;
    Identifier1,Identifier2 : Varstring;
    Begin1,Begin2 : Integer := Complete;
    End1,End2 : Integer := Complete;
    Adjust : Integer := 0;
    Format1,Format2 : Sequence_Format := Unknown;
    Model1,Model2 : Sequence_Model := No;
    Inverse1,Inverse2 : Boolean := False;
    Complementaire1,Complementaire2 : Boolean := False;
    Strand1,Strand2 : Strand_Type := Watson;
    Interactif : Boolean := False;
    Listfile : Varstring;
    Posfile : Varstring;
    Poslist : Boolean := False;
    Print_Result : Boolean := False;
    Print_Summary : Boolean := False;
    Summary : Boolean := True;
    Max_Length : Integer := 3500;
    Matrix : Varstring; 
    Match_Weight : Integer := 10;  -- Paramtre par dfaut de GCG/Bestfit
    Mismatch_Weight : Integer := -9;
    Gap_Weight : Integer := -50;
    Gap_Length_Weight : Integer := -3;
    With_End_Weight   : Boolean := False;
    Similarity_Threshold : Integer := -1; -- calcul automatique du seuil
    Randomization : Integer := 0;
    Preserve : Integer := 1;
    Lmin : Integer := 0; -- longueur minimale pour retenir un alignement
    Smin : Percentage := 0.0; -- idem pour le pourcentage d'identite
  end record;

  procedure Get_Options(Options : in out Options_Type);
  -- Analyse de la ligne de commande

  procedure Print_Options;
  -- Affichage de la liste des options

end Yaap_Options;
